Package com.sas.metadata.remote

# Interface CustomAssociation

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface CustomAssociation extends SecondaryType
Defines a custom association between any two metadata objects.

Attributes of CustomAssociation are:

- `PartnerName`
- `isOwned`

Associations of CustomAssociation are:

- `AssociatedObjects`
- `OwningObject`

## Usage

To create an instance of this CustomAssociation, use the `factory` create methods.
Example: create a CustomAssociation with name "CustomAssociation_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     CustomAssociation myObject = (CustomAssociation) factory.createComplexMetadataObject(objectStore, "CustomAssociation_Object", MetadataObjects.CUSTOMASSOCIATION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDOBJECTS_NAME`
  Constant used for the name of the AssociatedObjects association.
  `static final String`
  `ASSOCIATION_OWNINGOBJECT_NAME`
  Constant used for the name of the OwningObject association.
  `static final String`
  `ATTRIBUTE_ISOWNED_NAME`
  Constant used for the name of the isOwned attribute.
  `static final String`
  `ATTRIBUTE_PARTNERNAME_NAME`
  Constant used for the name of the PartnerName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getAssociatedObjects()`
  Gets the Association list of `AssociatedObjects`
  `AssociationList`
  `getAssociatedObjects(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedObjects`
  `int`
  `getisOwned()`
  Gets the `int` value of `isOwned`
  `int`
  `getisOwnedState()`
  Gets the Metadata State of `isOwned`
  `Root`
  `getOwningObject()`
  Gets the `Root` for `OwningObject`
  `AssociationList`
  `getOwningObjects()`
  Gets the Association list of `OwningObjects`
  `AssociationList`
  `getOwningObjects(boolean fGoToServer)`
  Gets the Associationlist of `OwningObjects`
  `String`
  `getPartnerName()`
  Gets the `String` value of `PartnerName`
  `int`
  `getPartnerNameMaxLength()`
  Gets the maximum length of `PartnerName`
  `int`
  `getPartnerNameState()`
  Gets the Metadata State of `PartnerName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningObject`
  `void`
  `setAssociatedObjects(AssociationList list)`
  Sets the `AssociatedObjects` list to be `list`.
  `void`
  `setAssociatedObjects(AssociationList inObjects, int state)`
  Sets the entire AssociatedObjects list to match the passed in AssociationList, sets the state of the AssociatedObjects
  `void`
  `setisOwned(int inisOwned)`
  Sets the `isOwned` value and sets the state to MetadataState.LOCAL.
  `void`
  `setisOwned(int inisOwned, int state)`
  Sets the `isOwned` Metadata State.
  `void`
  `setisOwned(String inisOwned)`
  Sets the `isOwned` value and sets the state to MetadataState.LOCAL.
  `void`
  `setisOwned(String inisOwned, int state)`
  Sets the `isOwned` value and Metadata State.
  `void`
  `setisOwnedState(int state)`
  Sets the Metadata State of `isOwned`.
  `void`
  `setOwningObject(Root inObject)`
  Sets the `OwningObjects` list 0th element to be `inObject`.
  `void`
  `setOwningObjects(AssociationList list)`
  Sets the `OwningObjects` list to be `list`.
  `void`
  `setOwningObjects(AssociationList list, int state)`
  Sets the `OwningObjects` list to be `list`.
  `void`
  `setPartnerName(String inPartnerName)`
  Sets the `PartnerName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPartnerName(String inPartnerName, int state)`
  Sets the `PartnerName` Metadata State.
  `void`
  `setPartnerNameState(int state)`
  Sets the Metadata State of `PartnerName`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_PARTNERNAME_NAME

    static final String ATTRIBUTE_PARTNERNAME_NAME
    Constant used for the name of the PartnerName attribute.

    PartnerName: The name of this custom association as referenced by the referenced object(s).

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ISOWNED_NAME

    static final String ATTRIBUTE_ISOWNED_NAME
    Constant used for the name of the isOwned attribute.

    isOwned: An associated object should be deleted with the owning object if this value is true (!=0).

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDOBJECTS_NAME

    static final String ASSOCIATION_ASSOCIATEDOBJECTS_NAME
    Constant used for the name of the AssociatedObjects association.

    AssociatedObjects: The custom associations that reference this object.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGOBJECT_NAME

    static final String ASSOCIATION_OWNINGOBJECT_NAME
    Constant used for the name of the OwningObject association.

    OwningObject: The object that has this custom association.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningObject`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPartnerName

    String getPartnerName() throws RemoteException
    Gets the `String` value of `PartnerName`
    Returns:
      The `PartnerName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPartnerNameState

    int getPartnerNameState() throws RemoteException
    Gets the Metadata State of `PartnerName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPartnerNameMaxLength

    int getPartnerNameMaxLength() throws RemoteException
    Gets the maximum length of `PartnerName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getisOwned

    int getisOwned() throws RemoteException
    Gets the `int` value of `isOwned`
    Returns:
      The `isOwned`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getisOwnedState

    int getisOwnedState() throws RemoteException
    Gets the Metadata State of `isOwned`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects() throws RemoteException, MdException
    Gets the Association list of `AssociatedObjects`
    Returns:
      The AssociationList of `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningObjects

    AssociationList getOwningObjects() throws RemoteException, MdException
    Gets the Association list of `OwningObjects`
    Returns:
      The AssociationList of `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningObject

    Root getOwningObject() throws RemoteException, MdException
    Gets the `Root` for `OwningObject`
    Returns:
      The `Root` ( `null` if not set ) of `OwningObject` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningObjects

    AssociationList getOwningObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setPartnerName

    void setPartnerName(String inPartnerName) throws RemoteException
    Sets the `PartnerName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPartnerName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPartnerName

    void setPartnerName(String inPartnerName, int state) throws RemoteException
    Sets the `PartnerName` Metadata State.
    Parameters:
      `inPartnerName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPartnerNameState

    void setPartnerNameState(int state) throws RemoteException
    Sets the Metadata State of `PartnerName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setisOwned

    void setisOwned(int inisOwned) throws RemoteException
    Sets the `isOwned` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inisOwned` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setisOwned

    void setisOwned(int inisOwned, int state) throws RemoteException
    Sets the `isOwned` Metadata State.
    Parameters:
      `inisOwned` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setisOwned

    void setisOwned(String inisOwned) throws RemoteException
    Sets the `isOwned` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inisOwned` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setisOwned

    void setisOwned(String inisOwned, int state) throws RemoteException
    Sets the `isOwned` value and Metadata State.
    Parameters:
      `inisOwned` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setisOwnedState

    void setisOwnedState(int state) throws RemoteException
    Sets the Metadata State of `isOwned`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList list) throws RemoteException
    Sets the `AssociatedObjects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedObjects

    void setAssociatedObjects(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociatedObjects list to match the passed in AssociationList, sets the state of the AssociatedObjects
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list, int state) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObject

    void setOwningObject(Root inObject) throws RemoteException
    Sets the `OwningObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.